#include "Frame.h"

#ifdef WIN32
#include <windows.h>
#else
#include <sys/time.h>
#endif

unsigned long getNow(void)
{
#if defined(WIN32)

	return (unsigned long)timeGetTime();

#else

	struct timeval		tm;
	unsigned long		retVal;

	gettimeofday(&tm, NULL);
	retVal = (tm.tv_sec % 16777216) * 1000;
	retVal += tm.tv_usec/1000;
	return retVal;

#endif
}

//======================================================
//RXgN^
//======================================================
fkut_FPS::fkut_FPS(unsigned long dwFps, fk_FrameMode argMode)
{
	memset(this, 0, sizeof(fkut_FPS));
	m_bInit = 1;
	setFrameMode(argMode);
	setFPS(dwFps);

#ifdef WIN32
	timeBeginPeriod(1);
#endif
	return;
}


//======================================================
//fXgN^
//======================================================
fkut_FPS::~fkut_FPS()
{
#ifdef WIN32
	timeEndPeriod(1);
#endif
}

//======================================================
//ŎԐ܂B
//======================================================
bool fkut_FPS::update()
{
	m_dwFrameCount++;

	// R[
	if(m_bInit == 1) {
		m_dwLastMinitues = getNow();
		m_bInit = 0;
		m_bDrawFlag = 1;
		return m_bDrawFlag;
	}

	if((m_mode & FKUT_SKIP_FRAME) != 0 && timeGetTime()  > (DWORD)((m_dwFrameCount + 1) * m_fFrameTime + m_dwLastMinitues)) {
		// `XLbvLɂȂĂꍇ́A`tOԂăXLbvJEg
		m_bDrawFlag = 0;
		m_dwSkipCount++;
	} else if((m_mode & FKUT_WAIT_FRAME) != 0) {
		// FPSێ[hLɂȂĂꍇ́A]̎ԂSleepĂԂ
		unsigned long dwTime = (unsigned long)(m_dwFrameCount * m_fFrameTime + m_dwLastMinitues);
		while(timeGetTime() <= dwTime) {
			Sleep(1);
		}
		m_bDrawFlag = 1;
	}

	// 1bo߂JE^[Zbg	
	if(timeGetTime() - m_dwLastMinitues >= 1000) {
		m_dwLastMinitues = timeGetTime();
		m_dwFrameRate = m_dwFrameCount;
		m_dwFrameCount = 0;
		m_dwSkipRate = m_dwSkipCount;
		m_dwSkipCount = 0;
	}

	return m_bDrawFlag;
}

//======================================================
//t[XLbv邩Ȃݒ肵܂B
//======================================================
void fkut_FPS::setFrameMode(fk_FrameMode argMode)
{
	m_mode = argMode;
}

//======================================================
//FPSݒ肷B
//======================================================
void fkut_FPS::setFPS(unsigned long fps)
{
	m_fFrameTime = 1000.0f / fps;
}


//======================================================
//Ńt[[g擾܂B
//======================================================
unsigned long fkut_FPS::getFPS()
{
	return m_dwFrameRate;
}

//======================================================
//ŃXLbv[g擾܂B
//======================================================
unsigned long fkut_FPS::getSkipRate()
{
	return m_dwSkipRate;
}

//======================================================
//`悷邩Ȃ𔻒
//======================================================
bool fkut_FPS::getDrawFlag()
{
	return m_bDrawFlag;
}
